<?php

namespace Drupal\hash_tag_make\Plugin\Filter;

use Drupal\filter\FilterProcessResult;
use Drupal\filter\Plugin\FilterBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * @Filter(
 *   id = "filter_hash_tag_make",
 *   title = @Translation("Hash Tag Make Filter"),
 *   description = @Translation("Turn strings beginning with '#' into links with search url href value."),
 *   type = Drupal\filter\Plugin\FilterInterface::TYPE_MARKUP_LANGUAGE,
 * )
 */
class FilterHashTagMake extends FilterBase {

  public function process($text, $langcode) {

    $text = preg_replace(
        // Search for any string that starts with '#'.
        '/(?:^|\s+)(#\w+)/',
        // Wrap any string that starts with '#' in an <a> tag.
        ' <a href="/search/node?keys=$1" class="hashtag">$1</a>',
        // Replace the original value.
        $text
      );

    return new FilterProcessResult($text);
  }

}
